/*""FILE COMMENT""**********************************************************************
*  
*  	System Name  : H8S/2472 Sample Program                                                                   
*  	FILE Name    : ether.h
*  	Version      : 1.00.00
*  	Contents     : wb_t@C  
*  	Model        :                                                                                                                         
*  	CPU          : H8S/2472                                                
*  	Compiler     : 
*  	OS           : None
*  
*  	note         : MfBXNv^AMobt@ݒ̎QlvOłB
*                    <ӎ>
*@@@    @@@@@{TvvOׂ͂ĎQlł
*                    ̓ۏ؂̂ł͂܂B
*@@@@@@@@    {TvvO͂ql̃\tgEGAJ
*A@@@@@@    @ZpQlƂĂpB
*                                                                      
* 
* 	Copyright  (C)  2007 Renesas Technology Corp. All Rights Reserved
* @ 	AND Renesas Solutions Corp. All Rights Reserved
*                                                                    
*  	history      : 2007.02.19 ver 1.00.00
*""FILE COMMENT END""*******************************************************************/
#ifndef _ETHER_H
#define _ETHER_H

/* ==== OQƃvg^Cv錾 ==== */
int lan_open(void);
int lan_recv(unsigned char *addr);
int lan_send(unsigned char *addr, int flen);
int lan_close(void);

/* ==== }N` ==== */
#define NUM_OF_TX_DESCRIPTOR	     2	   /* MpfBXNv^̌ */
#define NUM_OF_RX_DESCRIPTOR	     2	   /* MpfBXNv^̌ */
#define	SIZE_OF_TX_BUFFER         1520	   /* Mobt@TCY 16oCg̐{ɂ邱 */
#define	SIZE_OF_RX_BUFFER         1520     /* Mobt@TCY 16oCg̐{ɂ邱 */
//#define	MAC_ADDRESS_HIGH0	0x01234567	   /* MACAhX01-23-45-67-89-AB(16i)̏ꍇ */	
//#define	MAC_ADDRESS_LOW0	0x000089AB	
//#define	MAC_ADDRESS_HIGH0	0x001125bc	   /* MACAhX01-23-45-67-89-AB(16i)̏ꍇ */	
//#define	MAC_ADDRESS_LOW0	0x0000fd0a	
#define	MAC_ADDRESS_HIGH1	0x01234567	   /* MACAhX01-23-45-67-89-AA(16i)̏ꍇ */	
#define	MAC_ADDRESS_LOW1	0x000089AA
#define EDMAC0_PRIORITY            0xf	   /* E-DMAC0̗D惌x */
#define EDMAC1_PRIORITY            0xf	   /* E-DMAC1̗D惌x */
#define	TX_FLAG_ON	1
#define	TX_FLAG_OFF	0
#define FRAME_TRANSMIT_COMPLETE 0x00200000

/* ==== lan_open()p߂l̗񋓒萔` ==== */
typedef enum{OPEN_OK= 0,OPEN_NG= -1}OPEN_STATUS;

/* ==== lan_send()p߂l̗񋓒萔` ==== */
typedef enum{SEND_OK = 0,SEND_NG =-1}SEND_STATUS;

/* ==== lan_close()p߂l̗񋓒萔` ==== */
typedef enum{CLOSE_OK= 0,CLOSE_NG= -1}CLOSE_STATUS;

/* ==== MfBXNv^\̒` ==== */
typedef union
{
	unsigned long LONG;
	struct{
		unsigned int	TACT:1;			/* MfBXNv^Lrbg */
		unsigned int	TDLE:1;			/* MŏIfBXNv^XgŏI */
		unsigned int	TFP:2;			/* Mt[ʒu */
		unsigned int	TFE:1;			/* Mt[G[(G[̗v TFSx Q) */
		unsigned int	reserved1:11;	/* gp */
		unsigned int	reserved2:7;	/* gp */
		unsigned int	TFS8:1;			/* MA{[g */
		unsigned int	reserved3:4;	/* gp */
		unsigned int	TFS3:1;			/* MJnLAo */
		unsigned int	TFS2:1;			/* MLA */
		unsigned int	TFS1:1;			/* xՓ˔ */
		unsigned int	TFS0:1;			/* MgCI[o */
	}BIT;
}TD0;
typedef struct
{
	unsigned short	TDL;			/* Mobt@̃TCY(oCg) */
	unsigned short	reserved;
}TD1;
typedef struct
{
	unsigned char	*TBA;			/* Mobt@̃AhX */
}TD2;

typedef struct tag_edmac_send_desc
{
	TD0    td0;
	TD1    td1;
	TD2    td2;
    struct	tag_edmac_send_desc    *pNext;
}EDMAC_SEND_DESC;

/* ==== MfBXNv^\̒` ==== */
typedef union
{
	unsigned long LONG;
	struct{
		unsigned int	RACT:1;			/* MfBXNv^L */
		unsigned int	RDLE:1;			/* ŏIfBXNv^XgŏI */
		unsigned int	RFP:2;			/* ft[ʒu */
		unsigned int	RFE:1;			/* Mt[G[(G[̗v TFSx Q) */
		unsigned int	reserved1:3;	/* gp */
		unsigned int	reserved2:8;	/* gp */
		unsigned int	reserved3:6;	/* gp */
		unsigned int	RFS9:1;			/* MFIFOI[ot[ */
		unsigned int	RFS8:1;			/* MA{[go */
		unsigned int	RFS7:1;			/* }`LXgAhXt[f */
		unsigned int	reserved4:2;	/* gp */
		unsigned int	RFS4:1;			/* [rbgt[G[ */
		unsigned int	RFS3:1;			/* Ot[MG[ */
		unsigned int	RFS2:1;			/* V[gt[MG[ */
		unsigned int	RFS1:1;			/* PHY-LSIMG[ */
		unsigned int	RFS0:1;			/* Mt[CRCG[ */
	}BIT;
}RD0;
typedef struct
{
	unsigned short	RBL;			/* Mobt@f[^(PʁFoCgA16oCgEŎw) */
	unsigned short	RDL;			/* Mf[^(t[̍ŌMƂɐݒ) */
}RD1;
typedef struct
{
	unsigned char	*RBA;			/* Mobt@̊JnAhXASDRAM16oCgE */
}RD2;

typedef struct tag_edmac_recv_desc 
{
	RD0    rd0;
	RD1    rd1;
	RD2    rd2;
    struct	tag_edmac_recv_desc  *pNext;
}EDMAC_RECV_DESC;

/* ==== Mobt@\̒` ==== */
typedef struct
{
	/* Mobt@̈(16oCgEŃACĂ邱) */                                               
	unsigned char	send_buf[NUM_OF_TX_DESCRIPTOR][SIZE_OF_TX_BUFFER];   
       
	/* Mobt@̈(16oCgEŃACĂ邱) */
	unsigned char	recv_buf[NUM_OF_RX_DESCRIPTOR][SIZE_OF_RX_BUFFER];
}TXRX_BUFFER_SET;

/* ==== MfBXNv^\̒` ==== */
typedef struct
{
	/* MfBXNv^(16oCgEŃACĂ邱) */
	EDMAC_SEND_DESC    send_desc[NUM_OF_TX_DESCRIPTOR];

	/* MfBXNv^(16oCgEŃACĂ邱) */
	EDMAC_RECV_DESC    recv_desc[NUM_OF_RX_DESCRIPTOR];
}TXRX_DESCRIPTOR_SET;

#endif

/* End of File */