/* Copyright 2003, RENESAS TECHNOLOGY CORPORATION */

/* $RCSfile: config_tcpudp.c,v $ */
/* $Revision: 1.12 $ */
/* $Date: 2004/06/15 00:20:37 $ */
 
/*
 *  T2̃RtBM[Vt@C
 *    ̒`ɂAT2Cu RAM gp(X^bN)m肷B
 *    TCÝAtcpudp_get_ramsize() ̃^[lŒׂ邱ƂłB
 *	  ϐɑ΂const錾ɂẮAȉ̕ϐăJX^}CY\B
 *			tcpudp_env, _myethaddr 
 */
#include "itcpip.h"

/****************************************************************************/
/**************************     TCP ֘A̒`     **************************/
/****************************************************************************/
/***  TCP t̒` (|[gԍ̂ݐݒv) ***/
const T_TCP_CREP tcp_crep[] = {
 /* { t, {ǂIPAhXCǂ̃|[gԍ)}} */
    { 0x0000, { 0, 80 }}
};
const H __tcprepn = sizeof(tcp_crep)/sizeof(T_TCP_CREP);	/* TCPt̑   */


/***  TCP ʐM[_̒` (MEBhETCŶݐݒv)***/
const T_TCP_CCEP tcp_ccep[] = {
 /* {TCP ʐM[_,
	 MpEBhEobt@̐擪, MpEBhEobt@̃TCY,
	 MpEBhEobt@̐擪, MpEBhEobt@̃TCY,
	 R[obN[`}
 */
	{ 0, 0, 0, 0, 1460, 0 }
};
const H __tcpcepn = sizeof(tcp_ccep)/sizeof(T_TCP_CCEP);	/* TCPʐM[_̑ */

/*** TCPMSS ***/
const UH _tcp_mss = 1460;					/* őF1460oCg */

/*** V[PXԍ̏l (0ȊO̒lݒ) ***/
UW	_tcp_initial_seqno = 1;

/*** 2MSL҂ (PʁF10ms) ***/
const UH	_tcp_2msl = (1*60*(1000/10));	     	/* 1 */

/*** ē]^CAEg̍ől  (PʁF10ms) ***/
const UH	_tcp_rt_tmo_rst = (10*60*(1000/10)); 	/* 10 */


/****************************************************************************/
/**************************     UDP ֘A̒`     **************************/
/****************************************************************************/
/***  UDP ʐM[_̒`  ***/
const T_UDP_CCEP udp_ccep[] = {
    /* |[gԍ̂ݐݒ */
    { 0x0000, { 0, 1365 }, 0x00000000 },	/* ID:1A|[gԍ:1365 */
};
const H __udpcepn = (sizeof(udp_ccep)/sizeof(T_UDP_CCEP));

/***  }`LXgMTTL  ***/
const UB __multi_TTL = 1;


/****************************************************************************/
/**************************  IP֘A̒`               *********************/
/****************************************************************************/
#if defined(_ETHER)
const UH _ip_tblcnt = 3;
#define MY_IP_ADDR		192,168,123,222				/* ǂIPAhX  */
#define GATEWAY_ADDR	0,0,0,0					/* Q[gEFCAhX (S0̏ꍇ͖) */
#define SUBNET_MASK		255,255,255,0			/* Tulbg}XN  */
#elif defined(_PPP)
#define MY_IP_ADDR		0,0,0,0					/* ǂIPAhX(S0𐄏) */
#define GATEWAY_ADDR	0,0,0,0					/* Q[gEFCAhX(S0𐄏) */
#define SUBNET_MASK		0,0,0,0					/* Tulbg}XN(S0𐄏)  */
#endif

TCPUDP_ENV tcpudp_env = {
	{MY_IP_ADDR},
	{SUBNET_MASK},
	{GATEWAY_ADDR}
};


/****************************************************************************/
/**************************  hCo֘A̒`         *********************/
/****************************************************************************/
#if defined(_ETHER)
/*--------------------------------------------------------------------------*/
/*    Ethernet֘A̐ݒ                                                    */
/*--------------------------------------------------------------------------*/
/* ǂMACAhX(w莞͑S0ݒ) */
#define MY_MAC_ADDR		0x02,0x00,0x00,0x00,0x00,0x00	/* [JAhX */

UB _myethaddr[6]={MY_MAC_ADDR};


#elif defined(_PPP)
/*-----------------------------------------------;
---------------------------*/
/*    PPP֘A̐ݒ                                                         */
/*--------------------------------------------------------------------------*/
/* F؊֘A */
const UH ppp_auth		 = AUTH_PAP;			/* PAP,Fؖ */
const UB user_name[6]    = "abcde";				/* [U   */
const UB user_passwd[6]  = "abc00";				/* pX[h */

/* _CAbv֘A̐ݒ */
const UB peer_dial[] 	 = "0,123";				/* ̓dbԍ */
const UB at_commands[]   = "ATW2&C0&D0&S0M0S0=0S10=255X3";	/* fR}h */
#endif


/* Copyright 2003, RENESAS TECHNOLOGY CORPORATION */














