/* Copyright 2003, RENESAS TECHNOLOGY CORPORATION */

/* $RCSfile: main.c,v $ */
/* $Revision: 1.10 $ */
/* $Date: 2004/06/15 00:20:37 $ */


#include <string.h>
#include <itcpip.h>
#include <iodefine2472.h>

void main(void);
void echo_srv(void);

#define TCPUDP_WORK		(600/sizeof(UW))
UW tcpudp_work[TCPUDP_WORK];

void main()
{
	ER		ercd;
	W		size;
	int		i;
	
	/* TCP֘Aϐ̏ */
	size = tcpudp_get_ramsize();
	if (size > (TCPUDP_WORK*sizeof(UW))) while (1);

	ercd = tcpudp_open(tcpudp_work);
	if (ercd != E_OK) goto err_tcpudp_open;
	
#if defined(_PPP)
	/* VÃI[v   */
	sio_open(BR576);

	/* f̃I[v  */
	ercd = modem_open();
	if (ercd != E_OK) goto err_modem_open;

	/* PPP̃I[v */
	ercd = ppp_open();
	if (ercd != E_OK) goto err_ppp_open;

#elif defined(_ETHER)
	/* LANRg[N */
	ercd = lan_open();
	if (ercd != E_OK) goto err_lan_open;
#endif
	/*
	 * TCPGR[obNET[őN
	 */
	for (i = 0; i < 10; i++) {					/* ڑAؒf10JԂƏI */
		echo_srv();
	}

#if defined(_PPP)
err_ppp_open:
	/* PPP̃N[Y  */
	ppp_close();

err_modem_open:
	/* f̃N[Y  */
	modem_close();

	/* VÃN[Y */
	sio_close();

#elif defined(_ETHER)
err_lan_open:
	/* LANRg[̒~ */
	lan_close();
#endif

err_tcpudp_open:
	/* TCP֘ȀI */
	tcpudp_close();
}


/* TCPGR[obNET[o */
void echo_srv()
{
	T_IPV4EP	dstaddr;
	ER			ercd;
	ID			cepid, repid;
	UB			ch;

	/* tIDCʐM[_ID̐ݒ */
	repid = 1;
	cepid = 1;

	/* 󓮃I[v҂ */
	ercd = tcp_acp_cep(cepid, repid, &dstaddr, TMO_FEVR);
	if (ercd != E_OK) return;

	/* Mf[^Ԃ */
	while (1) {
		/* Mf[^҂ */
		ercd = tcp_rcv_dat(cepid, &ch, sizeof(ch), TMO_FEVR);
		if (ercd < 0)  break;					/* G[ */
		if (ercd == 0) break;					/* FINMCI */

		/* GR[EobN */
		ercd = tcp_snd_dat(cepid, &ch, sizeof(ch), TMO_FEVR);
		if (ercd < 0)  break;					/* G[ */
	}

	/* RlNṼN[Y */
	tcp_cls_cep(cepid, TMO_FEVR);	
}

void HardwareSetup(void)
{
	char *ptr = (char*)(0xffff86);
	
	SYSTEM.SUBMSTPAH.BIT.EtherC = 0;
	SYSTEM.SUBMSTPAH.BIT.EDMAC = 0;
	SYSTEM.SUBMSTPBH.BIT.EtherC = 0;
	SYSTEM.SUBMSTPBH.BIT.EDMAC = 0;
	SYSTEM.MDCR.BIT.EXPE = 0;		// 0:VO`bv[h  1:g[h
	SYSTEM.SYSCR.BIT.INTM = 1;		// ݃[hP

	/* W[XgbvRg[WX^ݒF^C}̗L */
	*ptr = 0;
		
}

/* Copyright 2003, RENESAS TECHNOLOGY CORPORATION */











